
#include <FastLED.h>
#define NUM_STRIPS 1
#define NUM_LEDS 300
#define LED_TYPE WS2812B
#define COLOR_ORDER BRG
#define FRAMES_PER_SECOND 60
#define DATA_PIN 8
#define LED_TYPE WS2812B
#define BRIGHTNESS Brightness
#define SATURATION Saturation
CRGB leds[NUM_LEDS];

int Vo;
int delai_on;
int delai_off;
int delai_rainbow;
int ThermistorPin = 0;
int Saturation = 255;
int Brightness = 255;
int sound_sensor = 4;
int Vstroboscope = 0;
int Vrainbow = 0;
int rouge = 0;
int vert = 0;
int bleu = 0;
int Vson = 0;
int val = 0;
char BluetoothData;
float R1 = 2000;
float logR2, R2, T, Tc, Tf;
float c1 = 1.009249522e-03, c2 = 2.378405444e-04, c3 = 2.019202697e-07;

void setup() {
  Serial.begin(9600);
  pinMode(2, OUTPUT);
  pinMode(sound_sensor, INPUT);
  FastLED.addLeds<LED_TYPE, DATA_PIN, COLOR_ORDER>(leds, NUM_LEDS);
  FastLED.clear();
  FastLED.show();
}

void loop() {
  if (Serial.available()) {
    BluetoothData = Serial.read();
    if (BluetoothData == 'R') Vrainbow = 1;
    if (BluetoothData == 'C') suppr();
    if (BluetoothData == 'B') Vson = 1;
    if (BluetoothData == 'O') Vstroboscope = 1;
    if (BluetoothData == 'D') delai_rainbow = Serial.parseInt();
    if (BluetoothData == 'M') delai_on = Serial.parseInt();
    if (BluetoothData == 'N') delai_off = Serial.parseInt();
    if (BluetoothData == 'J') rouge = Serial.parseInt();
    if (BluetoothData == 'K') vert = Serial.parseInt();
    if (BluetoothData == 'L') bleu = Serial.parseInt();
    if (BluetoothData == 'E') Saturation = Serial.parseInt();
    if (BluetoothData == 'F') Brightness = Serial.parseInt();
    if (BluetoothData == 'A') couleur();
  }

  if (Vrainbow == 1) rainbow();
  if (Vson == 1) son();
  if (Vstroboscope == 1) stroboscope();
//  Serial.print("*T" + String(Tc) + " C" + "*");
  temp();
  //delay(50);
}

void rainbow() {
  for (int j = 0; j < 255; j++) {
    for (int i = 0; i < NUM_LEDS; i++) {
      leds[i] = CHSV(i - (j * 2), BRIGHTNESS, SATURATION);
    }
    FastLED.show();
    delay(delai_rainbow);
  }
  if (Serial.available()) {
    BluetoothData = Serial.read();
    if (BluetoothData == 'C') suppr();
    if (BluetoothData == 'D') delai_rainbow = Serial.parseInt();
  }
  temp();
}

void suppr() {
  Vrainbow = 0;
  Vson = 0;
  Vstroboscope = 0;
  FastLED.clear();
  FastLED.show();
  delay(50);
}

void son() {

  val = digitalRead(sound_sensor);

  if (val == HIGH) {
    rouge = random(256);
    bleu = random(256);
    vert = random(256);
    for (int i = 0; i < NUM_LEDS; ++i) {
    val = digitalRead(sound_sensor);
      leds[i] = CRGB(rouge, bleu, vert); }
    FastLED.show(); 
  //  if (Vson == 1) son();
    temp();
  }
  
  if (val == LOW) {
    val = digitalRead(sound_sensor);
    FastLED.clear();
    FastLED.show();
 //   if (Vson == 1) son();
 }

 /* if (Serial.available()) {
    BluetoothData = Serial.read();
    if (BluetoothData == 'C') suppr(); 
  } */
 //   if (Vson == 1) son();
    temp();
}

void couleur() {
  for (int i = 0; i < NUM_LEDS; ++i) {
    leds[i] = CRGB( rouge, bleu, vert);
  }
  FastLED.show();
}

void stroboscope() {

  if (Serial.available()) {
    BluetoothData = Serial.read();
    if (BluetoothData == 'C') suppr();
    if (BluetoothData == 'M') delai_on = Serial.parseInt();
    if (BluetoothData == 'N') delai_off = Serial.parseInt();
    if (BluetoothData == 'J') rouge = Serial.parseInt();
    if (BluetoothData == 'K') vert = Serial.parseInt();
    if (BluetoothData == 'L') bleu = Serial.parseInt();
  }

  for (int i = 0; i < NUM_LEDS; ++i) {
    leds[i] = CRGB( rouge, vert, bleu);
  }
  FastLED.show();
  delay(delai_on);

  for (int i = 0; i < NUM_LEDS; ++i) {
    leds[i] = CRGB::Black;
  }
  FastLED.show();
  delay(delai_off);
}

void temp() {
  Vo = analogRead(ThermistorPin);
  R2 = R1 * (1023.0 / (float)Vo - 1.0);
  logR2 = log(R2);  
  T = (1.0 / (c1 + c2 * logR2 + c3 * logR2 * logR2 * logR2));
  Tc = T - 273.15;

  if (Tc > 50) {
    digitalWrite(2, HIGH);
    Serial.print("*XR255G0B0*");
    delay(50);
    digitalWrite(2, LOW);
    Serial.print("*XR0G0B0*");
    delay(50);
  }

  Serial.print("*T" + String(Tc) + " C" + "*");
}
